--- src/nntpcache.c.orig	2002-04-05 20:29:58.000000000 +0200
+++ src/nntpcache.c	2003-07-28 14:02:21.000000000 +0200
@@ -1247,7 +1247,12 @@
 		Task = task_info_new (nc_master, "master");
 		watchInit();
 		drop_priv(ncUID, ncGID);
-		sprintf (PidFile, "%.127s.%.164s", con->pidFile, con->bindAddr);
+
+        if (strchr(con->pidFile, (int)'/') != NULL)
+            sprintf (PidFile, "%.127s", con->pidFile);
+        else
+            sprintf (PidFile, "%.127s.%.164s", con->pidFile, con->bindAddr);
+
 		if (!(fh = fopen (PidFile, "w")))
 			logw (("couldn't open pid file '%s'", PidFile));
 		else
@@ -1436,6 +1441,7 @@
     char *config_file = con->configFile;
     char *access_file = con->accessFile;
     char *bindAddr = NULL;
+    char *pidFile = NULL;
     struct hostent *hp;
     enum task_state task;
     char *p = NULL;
@@ -1456,7 +1462,7 @@
 	 assert(task_desc[nc_last] == NULL);
 	 task = nc_master;
 
-	 while ((c = getopt (argc, argv, "ef:hnb:rc:s")) != -1)
+	 while ((c = getopt (argc, argv, "ef:hnb:p:rc:s")) != -1)
 		switch (c)
 		{
 		case 'a':
@@ -1496,6 +1502,9 @@
 		case 'b':
 			bindAddr = Sstrdup(optarg);
 			break;
+		case 'p':
+			pidFile = Sstrdup(optarg);
+			break;
 		case 's':
 			SwapWithChild = TRUE;
 			break;
@@ -1563,6 +1572,10 @@
 		if (con->bindAddr) free(con->bindAddr);
 		con->bindAddr = Sstrdup(bindAddr);
 	}
+	if (pidFile) {
+		if (con->pidFile) free(con->pidFile);
+		con->pidFile = Sstrdup(pidFile);
+	}
 	if (chdir (con->configDir) == -1)
 	{
 		loge (("couldn't set cwd to %s", con->configDir));
